# listRows

## HTTP Request

```http
GET /tables/:tableReference/rows
```

## Path parameters

| Parameter      |                                                                                                                      |
| -------------- | -------------------------------------------------------------------------------------------------------------------- |
| tableReference | A qualified reference to the table. See [referencing resources](/api/referencing-resources.md) for more information. |

## Query parameters

| Parameter         |                                                                                                                                                                                                                                                                                      |
| ----------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| format            | The response format. Either `csv` , `jsonl`, or `arrow`. Defaults to `jsonl` for the JSON-lines format.                                                                                                                                                                              |
| selectedVariables | <p><strong>Optional</strong>. A comma separated list of the variables to return, case insensitive. The order of variables in this list will determine the order of values in the response.</p><p></p><p>If not specified, all variables belonging to the table will be returned.</p> |
| maxResults        | **Optional**. Maximum number of rows to return.                                                                                                                                                                                                                                      |

{% hint style="info" %}
This endpoint extends the [general API structure](/api/rest-api/general-structure.md).
{% endhint %}

## Authorization

{% hint style="info" %}
This endpoint is accessible without authorization for tables which are public and under 100MB. However, certain rate limits may be enforced (and may change in the future) for unauthenticated users – we still recommend providing authorization information in the request header whenever possible.
{% endhint %}

Data access to the table is required. If a table's data is not public, your access token must have one of the following scopes:

* data.data
* data.edit

[Learn more about authorization.](/api/rest-api/authorization.md)

## Request body

The request body must be empty.

## Response body

{% tabs %}
{% tab title="?format=jsonl" %}
The response is returned in the [JSON Lines format](https://jsonlines.org/), with each row represented as an object of key:value pairs.&#x20;

<pre class="language-javascript"><code class="lang-javascript"><strong>// e.g.: ...table_ref/rows?selectedVariables=id,date,decimal,text
</strong>{"id":1, "date":"2012-01-01", "decimal":4.2, "text":"Some text"]
{"id":2, "date":"2012-01-01", "decimal":3.14, "text":"More text"]
...
</code></pre>

Please note the following regarding response data formats:

* Date variables are formatted as `YYYY-MM-DD`
* DateTime variables are formatted at `YYYY-MM-DD HH:MM:SS[.DDDDDD]`&#x20;
* Time variables are formatted as `HH:MM:SS[.DDDDDD]`
* Geography variables are formatted as [well-known text (WKT)](https://en.wikipedia.org/wiki/Well-known_text_representation_of_geometry)
  {% endtab %}

{% tab title="?format=csv" %}
The response is returned as a comma-separated file.

<pre class="language-csv"><code class="lang-csv"><strong>// e.g.: table_ref/rows?format=csv&#x26;selectedVariables=id,date,decimal,text
</strong>id,date,decimal,text
1,"2012-01-01",4.2,"Some text"
2,"2012-02-02",3.14,"Some other text"
3, ...
</code></pre>

Please note the following regarding response data formats:

* Date variables are formatted as `YYYY-MM-DD`
* DateTime variables are formatted at `YYYY-MM-DD HH:MM:SS[.DDDDDD]`&#x20;
* Time variables are formatted as `HH:MM:SS[.DDDDDD]`
* Geography variables are formatted as [well-known text (WKT)](https://en.wikipedia.org/wiki/Well-known_text_representation_of_geometry)
  {% endtab %}

{% tab title="?format=arrow" %}
Response is returned in the binary arrow IPC stream format.
{% endtab %}
{% endtabs %}

&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.redivis.com/api/rest-api/tables/listrows.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
